'use strict';function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
if (!Object.entries) {
  Object.entries = function (obj) {
    var ownProps = Object.keys(obj),
        i = ownProps.length,
        resArray = new Array(i); // preallocate the Array

    while (i--) {
      resArray[i] = [ownProps[i], obj[ownProps[i]]];
    }

    return resArray;
  };
}

var arr1 = [1, 2, 3, 4, 5, 6, 7, 8, 9, "", 0, -1];
var arr2 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 0, "", -1];
var script = {
  name: "VueNumericKeypad",
  props: {
    id: {
      type: String,
      required: false
    },
    value: {
      type: String,
      default: "",
      required: true
    },
    show: {
      type: [Boolean, Number],
      default: false,
      required: true
    },
    encryptFunc: {
      type: Function,
      default: function _default(c) {
        return c;
      }
    },
    encryptedValue: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    options: {
      type: Object,
      default: function _default() {
        return {};
      },
      validator: function validator(value) {
        var keyArrayDisable = (value.keyArray || []).some(function (key) {
          switch (_typeof(key)) {
            case 'number':
              return !Number.isInteger(key) || key < -2 || key > 9;

            case 'string':
              return key;

            default:
              return false;
          }
        });

        if (keyArrayDisable) {
          console.error("KeyArray can contain only an integer 'number' between -2 and 9 and an empty 'string'.");
          return false;
        }

        var classDisable = Object.keys(value).some(function (key) {
          return /Class/.test(key) && /[^0-9A-z\-_ ]/.test(value[key]);
        });

        if (classDisable) {
          console.error("Class name can contain only 'a-z' and 'A-Z', '0-9', '_', '-', ' '.");
          return false;
        }

        return true;
      },
      required: false
    }
  },
  data: function data() {
    var _this = this;

    var columns = Number(this.options.columns) || 3;
    return {
      encrypt: Boolean(this.options.encrypt),
      encryptedChar: typeof this.options.encryptedChar === 'string' ? this.options.encryptedChar.substring(0, 1) : "0",
      keyArray: this.options.keyArray || (columns === 3 ? arr1 : arr2),
      keyRandomize: Boolean(this.options.keyRandomize === undefined || this.options.keyRandomize),
      randomizeWhenClick: Boolean(this.options.randomizeWhenClick),
      fixDeleteKey: Boolean(this.options.fixDeleteKey === undefined || this.options.fixDeleteKey),
      fixBlankKey: Boolean(this.options.fixBlankKey === undefined || this.options.fixBlankKey),
      stopPropagation: Boolean(this.options.stopPropagation === undefined || this.options.stopPropagation),
      keypadClass: this.options.keypadClass || 'numeric-keypad',
      buttonWrapClass: this.options.buttonWrapClass || 'numeric-keypad__button-wrap',
      buttonClass: this.options.buttonClass || 'numeric-keypad__button',
      deleteButtonClass: this.options.deleteButtonClass || 'numeric-keypad__button--delete',
      clearButtonClass: this.options.clearButtonClass || 'numeric-keypad__button--clear',
      blankButtonClass: this.options.blankButtonClass || 'numeric-keypad__button--blank',
      activeButtonClass: this.options.activeButtonClass || 'numeric-keypad__button--active',
      activeButtonIndexes: {},
      activeButtonDelay: Number(this.options.activeButtonDelay) || 300,
      pseudoClick: Boolean(this.options.pseudoClick),
      pseudoClickDeleteKey: this.options.pseudoClickDeleteKey === undefined ? Boolean(this.options.pseudoClick) : Boolean(this.options.pseudoClickDeleteKey),
      pseudoClickBlankKey: this.options.pseudoClickBlankKey === undefined ? Boolean(this.options.pseudoClick) : Boolean(this.options.pseudoClickBlankKey),
      vibrate: Boolean(this.options.vibrate),
      vibratePattern: this.options.vibratePattern || 200,
      rows: Number(this.options.rows) || 4,
      columns: columns,
      zIndex: Number(this.options.zIndex) || 1,
      cellWidth: 0,
      cellHeight: 0,
      defaultStyleSheet: document.createElement('style'),
      defaultStyle: ['all', 'button', 'wrap', 'none'].find(function (s) {
        return s === _this.options.defaultStyle;
      }) || 'all',
      keypadStylesIndex: null,
      deleteKeyText: this.options.deleteKeyText === undefined ? 'del' : this.options.deleteKeyText,
      clearKeyText: this.options.clearKeyText === undefined ? 'clr' : this.options.clearKeyText
    };
  },
  watch: {
    show: function show() {
      this.$nextTick(function () {
        if (this.show) this.resize();
      });
      if (this.keyRandomize) this.randomize();
    },
    options: {
      deep: true,
      handler: function handler(options) {
        if (_typeof(options) !== 'object') return;
        var columns = Number(options.columns) || 3;
        this.encryptedChar = typeof options.encryptedChar === 'string' ? options.encryptedChar.substring(0, 1) : "0";
        this.keyArray = options.keyArray || (columns === 3 ? arr1 : arr2);
        this.keyRandomize = Boolean(options.keyRandomize === undefined || options.keyRandomize);
        this.randomizeWhenClick = Boolean(options.randomizeWhenClick);
        this.fixDeleteKey = Boolean(options.fixDeleteKey === undefined || options.fixDeleteKey);
        this.fixBlankKey = Boolean(options.fixBlankKey === undefined || options.fixBlankKey);
        this.stopPropagation = Boolean(options.stopPropagation === undefined || options.stopPropagation);
        this.activeButtonDelay = Number(options.activeButtonDelay) || 300;
        this.pseudoClick = Boolean(options.pseudoClick);
        this.pseudoClickDeleteKey = options.pseudoClickDeleteKey === undefined ? Boolean(options.pseudoClick) : Boolean(options.pseudoClickDeleteKey);
        this.pseudoClickBlankKey = options.pseudoClickBlankKey === undefined ? Boolean(options.pseudoClick) : Boolean(options.pseudoClickBlankKey);
        this.vibrate = Boolean(options.vibrate);
        this.vibratePattern = this.vibratePattern || 200;
        this.rows = Number(options.rows) || 4;
        this.zIndex = Number(options.zIndex) || 1;
        this.deleteKeyText = options.deleteKeyText === undefined ? 'del' : options.deleteKeyText;
        this.clearKeyText = options.clearKeyText === undefined ? 'clr' : options.clearKeyText;
        var defaultStyle = ['all', 'button', 'wrap', 'none'].find(function (s) {
          return s === options.defaultStyle;
        }) || 'all';

        if (this.defaultStyle !== defaultStyle) {
          this.defaultStyle = defaultStyle;
          document.head.removeChild(this.defaultStyleSheet);
          this.defaultStyleSheet = document.createElement('style');

          if (this.defaultStyle !== 'none') {
            document.head.appendChild(this.defaultStyleSheet);
            this.initDefaultStyles(this.defaultStyleSheet.sheet);
          }
        }

        if (this.keyRandomize) this.randomize();
      }
    }
  },
  computed: {
    keypadStyles: function keypadStyles() {
      var fontSize = Math.round(Math.min(this.cellWidth, this.cellHeight) * 0.3);
      var style = "\n        position: fixed;\n        z-index: ".concat(this.zIndex, ";\n        bottom: 0;\n        left: 0;\n        right: 0;\n        height: 40vh;\n        padding: 10px;\n        background-color: #fff;\n        border-radius: 12px 12px 0 0;\n        box-shadow: 0 -4px 4px rgba(0, 0, 0, 0.15);\n        color: #000;\n        overflow: hidden;\n      ");
      return fontSize ? style + "\nfont-size: ".concat(fontSize, "px;") : style;
    },
    buttonWrapStyles: function buttonWrapStyles() {
      return "\n        display: flex;\n        witdth: 100%;\n        height: 100%;\n        justify-content: space-between;\n        align-content: space-between;\n        flex-wrap: wrap;\n        gridGap: 5px;\n      ";
    },
    buttonStyles: function buttonStyles() {
      var width = "calc(".concat(Math.round(1000 / this.columns) / 10, "% - ").concat(Math.ceil(5 * (this.columns - 1) / this.columns), "px)");
      var height = "calc(".concat(Math.round(1000 / this.rows) / 10, "% - ").concat(Math.ceil(5 * (this.rows - 1) / this.rows), "px)");
      return "\n        flex: 0 0 auto;\n        display: flex;\n        width: ".concat(width, ";\n        height: ").concat(height, ";\n        justify-content: center;\n        align-items: center;\n        background-color: #fff;\n        border: 1px solid #000;\n        border-radius: 8px;\n        font-size: inherit;\n      ");
    }
  },
  methods: {
    click: function click(key, idx, event) {
      if (!event.isTrusted) return;

      if (this.pseudoClick) {
        if (!((key == -1 || key == -2) && !this.pseudoClickDeleteKey || key == '' && !this.pseudoClickBlankKey)) {
          var l = this.keyArray.length;
          var pIdx = Math.floor(Math.random() * (l - 1) + idx + 1) % l;
          this.activeButton(pIdx);
        }
      }

      this.activeButton(idx);
      if (this.vibrate && window.navigator.vibrate) window.navigator.vibrate(this.vibratePattern);

      switch (key) {
        case -1:
          this.del();
          break;

        case -2:
          this.clear();

        case "":
          break;

        default:
          this.add(key);
          break;
      }

      if (this.keyRandomize && this.randomizeWhenClick) this.randomize();
    },
    del: function del() {
      var encryptedValue = _toConsumableArray(this.encryptedValue);

      var newVal = this.value.slice(0, -1);
      this.$emit("update:value", String(newVal));

      if (this.encrypt) {
        encryptedValue.pop();
        this.$emit("update:encryptedValue", encryptedValue);
      }
    },
    clear: function clear() {
      this.$emit("update:value", '');
      if (this.encrypt) this.$emit("update:encryptedValue", []);
    },
    add: function add(key) {
      var encryptedValue = _toConsumableArray(this.encryptedValue);

      var newVal = this.value;

      if (this.encrypt) {
        newVal += this.encryptedChar;
        encryptedValue.push(this.encryptFunc(key.toString()));
        this.$emit("update:encryptedValue", encryptedValue);
      } else {
        newVal += key;
      }

      this.$emit("update:value", String(newVal));
    },
    randomize: function randomize() {
      var l = this.keyArray.length;

      var newkeyArray = _toConsumableArray(this.keyArray);

      for (var i = 0; i < l; i++) {
        var key = newkeyArray[i];
        if (this.checkFix(key)) continue;
        var r = Math.floor(Math.random() * l);
        if (r == i) r = (r + 1) % l;
        var count = 0;

        while ((this.checkFix(newkeyArray[r]) || newkeyArray[r] === newkeyArray[i]) && count < l) {
          r = (r + 1) % l;
          count++;
        }

        if (count >= l) continue;
        newkeyArray[i] = newkeyArray[r];
        newkeyArray[r] = key;
      }

      this.keyArray = newkeyArray;
    },
    checkFix: function checkFix(key) {
      if (key === '' && this.fixBlankKey) return true;
      if (key === -1 && this.fixDeleteKey) return true;
      if (key === -2 && this.fixDeleteKey) return true;
      return false;
    },
    showKey: function showKey(key) {
      if (key === -1) {
        return this.deleteKeyText;
      } else if (key === -2) {
        return this.clearKeyText;
      } else return key;
    },
    resize: function resize() {
      this.cellWidth = this.$refs.button[0].offsetWidth;
      this.cellHeight = this.$refs.button[0].offsetHeight;
      var sheet = this.defaultStyleSheet.sheet;

      if (sheet && this.keypadStylesIndex !== null) {
        sheet.deleteRule(0);
        sheet.insertRule(".".concat(this.keypadClass.trim().split(' ')[0], " {").concat(this.keypadStyles, "}"), 0);
      }
    },
    setClass: function setClass(key, idx) {
      var classArr = [this.buttonClass];

      if (key === -1) {
        classArr.push(this.deleteButtonClass);
      }

      if (key === -2) {
        classArr.push(this.clearButtonClass);
      }

      if (key === '') {
        classArr.push(this.blankButtonClass);
      }

      if (this.activeButtonIndexes[idx]) {
        classArr.push(this.activeButtonClass);
      }

      return classArr;
    },
    activeButton: function activeButton(idx) {
      var _this2 = this;

      if (this.activeButtonIndexes[idx]) {
        clearTimeout(this.activeButtonIndexes[idx]);
      } else {
        this.$refs.button[idx].classList.add(this.activeButtonClass);
      }

      this.activeButtonIndexes[idx] = setTimeout(function () {
        _this2.$refs.button[idx].classList.remove(_this2.activeButtonClass);

        clearTimeout(_this2.activeButtonIndexes[idx]);
        delete _this2.activeButtonIndexes[idx];
      }, this.activeButtonDelay);
    },
    initDefaultStyles: function initDefaultStyles(sheet) {
      if (this.defaultStyle === 'none') return;
      var test = /[^0-9A-z\-_ ]/;
      var padIndex = 0;

      if (this.defaultStyle !== 'button') {
        if (!test.test(this.keypadClass)) {
          this.keypadStylesIndex = padIndex;
          sheet.insertRule(".".concat(this.keypadClass.trim().split(' ')[0], " {").concat(this.keypadStyles, "}"), padIndex++);
        }

        if (!test.test(this.buttonWrapClass)) {
          sheet.insertRule(".".concat(this.buttonWrapClass.trim().split(' ')[0], " {").concat(this.buttonWrapStyles, "}"), padIndex++);
        }
      }

      if (this.defaultStyle !== 'wrap') {
        if (!test.test(this.buttonClass)) {
          sheet.insertRule(".".concat(this.buttonClass.trim().split(' ')[0], " {").concat(this.buttonStyles, "}"), padIndex++);

          if (!test.test(this.activeButtonClass)) {
            sheet.insertRule(".".concat(this.buttonClass.trim().split(' ')[0], ".").concat(this.activeButtonClass.trim().split(' ')[0], " {background-color: #eaeaea;}"), padIndex++);
          }
        }
      }
    }
  },
  mounted: function mounted() {
    window.addEventListener('resize', this.resize);

    if (this.defaultStyle !== 'none') {
      document.head.appendChild(this.defaultStyleSheet);
      this.initDefaultStyles(this.defaultStyleSheet.sheet);
    }

    if (this.keyRandomize) this.randomize();
    this.resize();
  },
  beforeDestroy: function beforeDestroy() {
    window.removeEventListener('resize', this.resize);
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.show,
      expression: "show"
    }],
    class: _vm.keypadClass,
    attrs: {
      "id": _vm.id
    },
    on: {
      "click": function click($event) {
        _vm.stopPropagation && $event.stopPropagation();
      }
    }
  }, [_vm._ssrNode("<div" + _vm._ssrClass(null, _vm.buttonWrapClass) + ">" + _vm._ssrList(_vm.keyArray, function (val, idx) {
    return "<button type=\"button\"" + _vm._ssrClass(null, _vm.setClass(val, idx)) + ">" + _vm._ssrEscape("\n      " + _vm._s(_vm.showKey(val)) + "\n    ") + "</button>";
  }) + "</div> "), _vm._t("default")], 2);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = undefined;
/* scoped */

var __vue_scope_id__ = undefined;
/* module identifier */

var __vue_module_identifier__ = "data-v-c821e51a";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

var component$1 = __vue_component__;// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var component = /*#__PURE__*/(function () {
  // Get component instance
  var installable = component$1; // Attach install function executed by Vue.use()

  installable.install = function (Vue) {
    Vue.component('VueNumericKeypad', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default': component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;